import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import quadbase.reportdesigner.ReportAPI.DBInfo;
import quadbase.reportdesigner.ReportAPI.QbReport;
import quadbase.reportdesigner.ReportViewer.Viewer;
import quadbase.reportdesigner.util.ColInfo;


public class MasterDetails extends Applet {
	static final long serialVersionUID = 1;

	public static void main(java.lang.String[] args) {

		try {

			MasterDetails doReport = new MasterDetails();
			Frame frame = new Frame();
			frame.setLayout(new BorderLayout());
			frame.add("Center", doReport.doMasterDetailsReport(frame));
			frame.setSize(1080, 800);
			frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setVisible(true);

		} catch (Exception ex) {

			ex.printStackTrace();

		}

	}

	public void init() {

		setLayout(new BorderLayout());
		add("Center", doMasterDetailsReport(this));

	}

	Component doMasterDetailsReport(Object parent)  {
		QbReport.setEspressManagerUsed(false);
		
		String url = "jdbc:hsqldb:database/woodview";
		String driver = "org.hsqldb.jdbcDriver";
		String query = "SELECT Order_Details.OrderID, Customers.CustomerID, Customers.ContactName, Customers.Company, Customers.Address, Customers.City, Customers.State, Customers.Zip, Categories.CategoryName, Products.ProductName, Products.UnitPrice, Products.StainPrice, Order_Details.Stain, Order_Details.StainColor, Order_Details.Quantity, Orders.OrderDate " +
"FROM Orders, Categories, Order_Details, Products, Customers " +
"WHERE (Products.CategoryID = Categories.CategoryID) " +
"AND (Order_Details.ProductID = Products.ProductID) " +
"AND (Order_Details.OrderID = Orders.OrderID) " +
"AND (Customers.CustomerID = Orders.CustomerID) " +
"AND (Orders.OrderDate BETWEEN '2003-05-01' AND '2003-05-31')";

		DBInfo dbInfo = new DBInfo(url, driver, "sa", "", query);
		
		ColInfo[] colInfo = new ColInfo[16];
		
		for(int i = 0; i < colInfo.length; i++){
			colInfo[i] = new ColInfo(i);
			if(i < 8)
				colInfo[i].setMaster(true);
		}
		colInfo[0].setPrimaryKey(true);
		colInfo[15].setVisible(false);
		
		QbReport report = new QbReport
								(parent,                // Parent
								QbReport.MASTERDETAILS, // Type of Report
								dbInfo,                   // Database Info
								colInfo,                // Column Mapping
								null);                  // Template Name
		try {
//			 Apply Template with Formula and Script
			report.applyTemplate("MasterDetails", true);
		} catch( Exception e ) {
			e.printStackTrace();
		}
		return (new Viewer().getComponent(report));

	}

}